/*	Pouzivane klavesy:
	L - zapne/vypne osvetlenie
	T - zapne/vypne texturovanie  
	P - zmeni polygon mod - vykresluje ciary	
	C - zapne/vypne riadenie viditelnosti
	
	Q,W - zmena ohniskovej vzdialenosti
	Y - zaostrenie
	U - automaticke zaostrovanie
	Z,X - zmena separacie oci
	I,O - nastavuje posunutie obrazkov v bezokuliarovaom mode
	E - reset stereo nastaveni
	S - vypne stereo
	D - prepina medzi modom s farebnymi okuliarmy a modom bez farebnych okuliarov
	J,K - zobrazi iba pravy, lavy pohlad

	R - reset pohladu
	H - help
	mys, tlacitka na mysi		- pohyb
	sipky, Page Up,Page Down	- pohyb
	shift - pomaly alebo rychli pohyb	
	1,2,3,4,5,6,7,8,9,0 - meni vykreslovanu plochu
	+ - na numerickej klavesnici - meni vykreslovanu plochu
	A - zapne/vypne animaciu
	V - zapne/vypne vyhlazovanie normalovych vektorov
	M - prepne na modelovanie riadiacej krivky
	  - naspat stlacenim praveho tlacitka
*/
#include "headers.h"
#define piover180	0.0174532925199432957692369076848861f	// pi / 180
extern bool	fullscreen;
float	fps;
char	text[20];
Camera	c;
Stereo	st(1);
Timer   timer0;

float uhol_x,uhol_y,uhol_z;

float	(*bod_m)[3];
int		bodov_,objekt=10;	// cislo resleneho objektu
float	anim,anim_;
bool	vyhladene_svetlo=1,svetlo=0,texturovanie=0,ciary=1,viditelnost=1,animacia=0,modelovanie=0;
bool	auto_focus=1;

void RotacnaPlocha(int delenie_dlzky,int delenie_uhla);
void RotacnaPlocha_Vyhladena(int delenie_dlzky,int delenie_uhla);
void RotacnaPlocha_Nevyhladena(int delenie_dlzky,int delenie_uhla);
void RotacnaPlocha_Texturovana_Nevyhladena(int delenie_dlzky,int delenie_uhla);
void RotacnaPlocha_Texturovana_bez_svetla(int delenie_dlzky,int delenie_uhla);
void RotacnaPlocha_Netexturovana_bez_svetla(int delenie_dlzky,int delenie_uhla);
void DrawGLScene_modelovanie(void);
void ReSizeGLScene_modelovanie(GLsizei width, GLsizei height);
void BezierovaKrivka_modelovanie(int stupen,float bod[][3],float t,float bod_vystup[3]);
void DrawGLScene_stereo(void);

void DrawGLScene(void)				// vlastn kreslenie
{	
	if(modelovanie){ DrawGLScene_modelovanie(); return; }

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	c.MoveWorld();					// otocenie sveta
	st.Update(c.Distance());
	if(keys['Y']) st.Set(c.Distance());
	if(keys['E'])					// reset nastavenie stereo
	{
		st.posuv = 0;
		st.sep = 30.0f;
		st.Set(c.Distance());
	}

	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }
	if(svetlo)glEnable(GL_LIGHTING);			// zapne svetlo

	if(keys['P']){	ciary = !ciary;	keys['P']=0; }
		
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	if(keys['T']){	texturovanie = !texturovanie;	keys['T']=0; }		
		
	if(!texturovanie)glDisable(GL_TEXTURE_2D);		// vypne texturovanie
	else glBindTexture(GL_TEXTURE_2D, texture[1]);		// nasavime aktualnu texturu pre texturovanie
	
	if(keys['V']){	vyhladene_svetlo = !vyhladene_svetlo; keys['V']=0; }
	if(keys['A']){	animacia = !animacia; keys['A']=0; }
	if(keys['C']){	viditelnost = !viditelnost; keys['C']=0; }
	if(keys['M'])
	{	
		modelovanie = !modelovanie;
		if(!fullscreen)
		{	RECT		WindowRect;					//miesto pre velkost okna
			WindowRect.left=(long)0;
			WindowRect.top=(long)0;
			GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov u6ivatelskej casti okna
			ReSizeGLScene_modelovanie(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
		}
		else ReSizeGLScene_modelovanie(screen_x, screen_y);	//definovana v tomto subore
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		return;
	}

	if(keys[VK_ADD]){ if(objekt<10)objekt++; keys[VK_ADD]=0; }
	else if (keys[VK_SUBTRACT]){ keys[VK_SUBTRACT]=0; if(objekt>0)objekt--; }
	if		(keys['1'])objekt=1;
	else if	(keys['2'])objekt=2;
	else if	(keys['3'])objekt=3;
	else if	(keys['4'])objekt=4;
	else if	(keys['5'])objekt=5;
	else if	(keys['6'])objekt=6;
	else if	(keys['7'])objekt=7;
	else if	(keys['8'])objekt=8;
	else if	(keys['9'])objekt=9;
	else if	(keys['0'])objekt=0;

	//glLineWidth(3.0f);
	if(!keys['S'])
	{
		// ----------- Lave oko --------------------------------------
		st.LeftEye();					// nastavenie projekcnej matice pre lave oko
		
		anim_=anim;				// zaloha pozicia animacie
		/*	(ciarovu) viditelnost je mozne riesit tak ze sa najprv vykresli vsetko ciernov farbov v
			mode vypnovania (GL_FILL) a potom sa vykresli ale uz s farbov vsetko este raz
			a ciary ktore su v pozadi sa nezobrazia		*/
		if(viditelnost &&( !(texturovanie&&(!ciary)) ))	// riesenie viditelnosti iba okrem pripadu vypnovania ploch a texturovania
		{
			if(texturovanie)glDisable(GL_TEXTURE_2D);	// vypne texturovanie - koli urychleniu
			if(svetlo)glDisable(GL_LIGHTING);			// vypne svetlo - koli urychleniu
			glColor3f(0,0,0);							// cierna farba
			glPolygonOffset( 1.f, 1.f);
			glEnable( GL_POLYGON_OFFSET_FILL);
			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);	// mod vplnovanie ploch
			DrawGLScene_stereo();						// zapiseme vsetko do Z buffera bez vykreslenia na obrazovku
			if(svetlo)glEnable(GL_LIGHTING);			// nastavi naspet svetlo
			if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);	// nastavime povodny polygon mod
			else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
			if(texturovanie)glEnable(GL_TEXTURE_2D);	// nastavime povodne
			glDisable( GL_POLYGON_OFFSET_FILL);
			anim=anim_;
		}	

		if(st.glasses)
		{
			GLfloat LightDiffuse[]	=	{ 1.0f, 0.0f, 0.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
			glColor3f(1,0,0);		// cervena farba pre prave oko
		}
		else
		{	
			GLfloat LightDiffuse[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
			glColor3f(1,1,1);
		}

		DrawGLScene_stereo();
		anim=anim_;

		// ----------- Prave oko -------------------------------------
		glEnable(GL_BLEND);				// zapneme miesanie farieb
		glClear(GL_DEPTH_BUFFER_BIT);	// znulovanie z buffera
		st.RightEye();					// nastavenie kreslenia pre prave oko
		
		if(viditelnost)	// riesenie viditelnosti iba okrem pripadu vypnovania ploch a texturovania
		{
			if(texturovanie)glDisable(GL_TEXTURE_2D);	// vypne texturovanie - koli urychleniu
			if(svetlo)glDisable(GL_LIGHTING);			// vypne svetlo - koli urychleniu
			glColor3f(0,0,0);							// cierna farba
			glPolygonOffset( 1.f, 1.f);
			glEnable( GL_POLYGON_OFFSET_FILL);
			glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);	// mod vplnovanie ploch
			DrawGLScene_stereo();						// zapiseme vsetko do Z buffera bez vykreslenia na obrazovku
			if(svetlo)glEnable(GL_LIGHTING);			// nastavi anspet svetlo
			if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);	// nastavime povodny polygon mod
			else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
			if(texturovanie)glEnable(GL_TEXTURE_2D);	// nastavime povodne
			glDisable( GL_POLYGON_OFFSET_FILL);
			anim=anim_;
		}

		if(st.glasses)
		{
			GLfloat LightDiffuse[]	=	{ 0.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
			glColor3f(0,1,1);			// zelenomodra farba pre lave oko
		}
		else
		{	
			GLfloat LightDiffuse[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
			glColor3f(1,1,1);
		}

		DrawGLScene_stereo();

		st.Center();
			
		// ----------------------------------------------------------
	}
	else 
	{
		GLfloat LightDiffuse2[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
		glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse2 );			// nastavenie difuzneho svetla
		glColor3f(1,1,1);			// zelenomodra farba pre lave oko
		DrawGLScene_stereo();
	}
	glDisable(GL_BLEND);

	glColor3f(1.0f,1.0f,1.0f);				// biela farba
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glDisable(GL_LIGHTING);					// vypnutie osvetlenia
	glEnable(GL_TEXTURE_2D);				// povolime texturovanie pre vypisovanie textu - v pripade ze je vypnute
	font0->Begin();

	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	gcvt( (double)fps, 4, text);			// prevod realneho cisla na text
	font0->Print(0,0,text,0);				// vypisanie textu na 0 stlpec a 0 riadok

	switch(objekt)
	{
	case 1:
			font0->Print(6,0,"cylinder",1);
			break;
	case 2:
			font0->Print(6,0,"cone",1);
			break;
	case 3:
			font0->Print(6,0,"sphere",1);
			break;
	case 4:
			font0->Print(6,0,"one-part rotated hyperboloid",1);
			break;
	case 5:
			font0->Print(6,0,"anuloid",1);
			break;
	case 6:
			font0->Print(6,0,"rotated elipsoid",1);
			break;
	case 7:	
			font0->Print(6,0,"rotated paraboloid",1);
			break;
	case 8:
			font0->Print(6,0,"rotated function sinus",1);
			break;
	case 9:
			font0->Print(6,0,"rotated Bezier curve",1);
			break;
	}

	if(keys['H'])							// zobrazenie helpu
	{
		font0->Print(15,3,"Program: Stereographic viewing 02 - rotate surface",0);
		glColor3f(0.9f,0.9f,1.0f);
		font0->Print(8,4,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
		glColor3f(1.0f,1.0f,1.0f);
		font0->Print(10,6,"Controls:",0);
		font0->Print(15,7,"L - on/off lighting",1);
		font0->Print(15,8,"T - on/off texturing",1);
		font0->Print(15,9,"P - wire frame",1);
		font0->Print(15,10,"C - on/off remove hidden lines",1);
		font0->Print(15,11,"Q,W - change focal length",1);
		font0->Print(15,12,"Y - focus",1);
		font0->Print(15,13,"U - automatic focus",1);
		font0->Print(15,14,"Z,X - change separation of eyes",1);
		font0->Print(15,15,"I,O - set shift pictures in without glasses mode",1);
		font0->Print(15,16,"E - reset stereo setting",1);
		font0->Print(15,17,"S - switch off stereo",1);
		font0->Print(15,18,"D - switch between glasses mode and witout glasses mode",1);
		font0->Print(15,19,"J,K - show only right, left view",1);	
		font0->Print(15,20,"R - reset camera",1);
		font0->Print(15,21,"H - help",1);
		font0->Print(15,22,"mouse, button on mouse - moving",1);
		font0->Print(15,23,"arrows, Page Up,Page Down - moving",1);
		font0->Print(15,24,"shift - slow moving",1);
		font0->Print(15,25,"1,2,3,4,5,6,7,8,9,0 - change drawing surface",1);
		font0->Print(15,26,"+ - on numeric. - change drawing surface",1);
		font0->Print(15,27,"A - on/off animation",1);
		font0->Print(15,28,"V - on/off smooth normal vectors",1);
		font0->Print(15,29,"M - switch to modeling control curve",1);
		font0->Print(15,30,"  - beck press right mouse button",1);
	}
	font0->End();
}

void DrawGLScene_stereo(void)
{
	glPushMatrix();
	
	if(objekt==10)
	{	
		bool	animacia_=animacia;
		
		objekt=3;		//gula
		glPushMatrix();
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		
		animacia=0;
		objekt=10;
		
		glPopMatrix();
		glPushMatrix();
		glTranslatef(-3.2f,0,0);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);
		
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,-3.2f,0);
		glRotatef(90,0,0,1);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);	

		glPopMatrix();
		glPushMatrix();
		glTranslatef(3.2f,0,0);
		glRotatef(180,0,0,1);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);

		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,3.2f,0);
		glRotatef(270,0,0,1);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);
		
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,0,3.2f);
		glRotatef(90,0,1,0);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);

		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,0,-3.2f);
		glRotatef(270,0,1,0);
		if(vyhladene_svetlo)RotacnaPlocha(1,20);
		else RotacnaPlocha_Texturovana_Nevyhladena(1,20);

		glPopMatrix();
		
		animacia=animacia_;
		glPopMatrix();
		return;
	}

	if(objekt==0)
	{
		float	anim__;
		anim__=anim;
		objekt=1;
		glPushMatrix();
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;
			
		glPopMatrix();
		glPushMatrix();
		objekt=2;
		glTranslatef(-5,5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;
		
		glPopMatrix();
		glPushMatrix();
		objekt=3;
		glTranslatef(-5,0,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;

		glPopMatrix();
		glPushMatrix();
		objekt=4;
		glTranslatef(-5,-5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;

		glPopMatrix();
		glPushMatrix();
		objekt=5;
		glTranslatef(0,-5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;

		glPopMatrix();
		glPushMatrix();
		objekt=6;
		glTranslatef(5,-5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;

		glPopMatrix();
		glPushMatrix();
		objekt=7;
		glTranslatef(5,0,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;

		glPopMatrix();
		glPushMatrix();
		objekt=8;
		glTranslatef(5,5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		anim=anim__;
		
		glPopMatrix();
		glPushMatrix();
		objekt=9;
		glTranslatef(0,5,0);
		if(vyhladene_svetlo)RotacnaPlocha(20,40);
		else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
		//anim=anim__;
		glPopMatrix();

		objekt=0;
		glPopMatrix();
		return;
	}
	
	if(vyhladene_svetlo)RotacnaPlocha(20,40);
	else RotacnaPlocha_Texturovana_Nevyhladena(20,40);
	glPopMatrix();
}

inline long double Comb(int pocet_prvkov,int trieda);	// kombinacie

void RiadiacaKrivka(float t,float *bod)			// t je z intervalu 0 <= t <= 1
{
	bod[2]=0;
	if(!animacia)
	{
		switch(objekt)
		{
		case 1:
				bod[0]= 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1]= 2;					// valec
				break;
		case 2:								// kuzel
				bod[0] = 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1] = 2 * t;
				break;
		case 3:								// gula o polomere 2
				t = t * 180 * piover180;	// 0 <= t <= pi
				bod[0] =-2 * (float) cos(t);
				bod[1] = 2 * (float) sin(t);
				break;
		case 4:								// jednodielny rotacny hyperboloid
				bod[0] = 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1] = 2 * t;
				bod[2] = 2 * (t-1);
				break;
		case 5:								// anuloid
				if(t==0)glRotatef(-90,0,1,0);		// aby bol otoceny k nam
				t = t * 360 * piover180;			// 0 <= t <= 2pi
				bod[0] =-(float) cos(t);
				bod[1] = (float) sin(t) + 2;
				bod[2] = 0;							// vyskusaj zmenit
				break;
		case 6:								// rotacny elipsoid
				t = t * PI;			// 0 <= t <= pi
				bod[0] =-3 * (float) cos(t);
				bod[1] = 2 * (float) sin(t);
				bod[2] = 0;							// vyskusaj zmenit
				break;
		case 7:								// rotacny paraboloid
				bod[0] = 4*t*t - 2;
				bod[1] = 2*t;
				bod[2] = 0;
				break;
		case 8:								// rotovana funkcia sinus
				bod[0] = 4 * (t-0.5f);
				t = t * 4 * PI;			// 0 <= t <= 2pi
				bod[1] = 2 * ( 0.5f*(float) sin(t) + 1.0f) ;
				break;
		case 9:								// rotovana Bezierova krivka
				if(bodov_>1)
				{
					BezierovaKrivka_modelovanie(bodov_,bod_m,t,bod);
					bod[0]=4*bod[0]-2;
					bod[1]=4*bod[1];
				}				
				break;
		case 10:								// kuzel
				bod[0] = (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1] = 0.5f * t;
				break;
		
		default:
				bod[0]= 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1]= 2;					// valec
				break;
		}
	}
	else
	{
		if(t==0)
		{
			anim+= 2.0f / fps;
			if(anim> (2*PI) )anim=0;
		}

		switch(objekt)
		{
		case 1:
				bod[0]= 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1]= 0.5f*(1.0f+(float)sin(anim))+1.0f;			// valec
				break;
		
		case 2:								// kuzel
				bod[0] = 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1] = (0.5f*(1.0f+(float)sin(anim))+1.0f) * t;
				break;
		case 3:								// gula o polomere 2
				t = t * 180 * piover180;	// 0 <= t <= pi
				bod[0] =-(0.5f*(1.0f+(float)sin(anim))+1.0f) * (float) cos(t);
				bod[1] = (0.5f*(1.0f+(float)sin(anim))+1.0f) * (float) sin(t);
				break;
		case 4:								// jednodielny rotacny hyperboloid
				bod[0] = 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1] = (0.5f*(1.0f+(float)cos(anim))+1.0f) * t;
				bod[2] = (0.5f*(1.0f+(float)sin(anim))+1.0f) * (t-1);
				break;
		case 5:								// anuloid
				if(t==0)glRotatef(-90,0,1,0);		// aby bol otoceny k nam
				t = t * 360 * piover180;			// 0 <= t <= 2pi
				bod[0] =-(0.5f*(1.0f+(float)sin(anim))+0.5f)*(float) cos(t);
				bod[1] = (0.5f*(1.0f+(float)cos(anim))+0.5f)*(float) sin(t) + 2;
				bod[2] = 0;							// vyskusaj zmenit
				break;
		case 6:								// rotacny elipsoid
				t = t * 180 * piover180;			// 0 <= t <= 2pi
				bod[0] =-(0.5f*(1.0f+(float)sin(anim))+1.0f) * (float) cos(t);
				bod[1] = (0.5f*(1.0f+(float)cos(anim))+1.0f) * (float) sin(t);
				bod[2] = 0;							// vyskusaj zmenit
				break;
		case 7:								// rotacny paraboloid
				bod[0] = 4*(float)pow(t,((1.0f+(float)sin(anim))+1.5f)) - 2;
				bod[1] = (0.5f*(1.0f+(float)sin(anim))+1.0f)*t;
				bod[2] = 0;
				break;
		case 8:								// rotovana funkcia sinus
				bod[0] = 4 * (t-0.5f);
				t = t * 4 * PI;				// 0 <= t <= 2pi
				t = t - anim;
				bod[1] = 2 * ( 0.5f*(float) sin(t) + 1.0f) ;
				break;
		case 9:								// rotovana Bezierova krivka
				if(bodov_>1)
				{
					int	i;
					for(i=1;i<(bodov_-1);i++)bod_m[i][1]=bod_m[i][1]*((1.0f+(float)sin(anim)));
					BezierovaKrivka_modelovanie(bodov_,bod_m,t,bod);
					for(i=1;i<(bodov_-1);i++)bod_m[i][1]=bod_m[i][1]/((1.0f+(float)sin(anim)));
					bod[0]=4*bod[0]-2;
					bod[1]=4*bod[1];
				}		
				break;
		default:
				bod[0]= 4 * (t-0.5f);		// -2 <= bod[0] <= 2
				bod[1]= 0.5f*(1.0f+(float)sin(anim))+1.0f;			// valec
		}
	}
}

void RotacnaPlocha(int delenie_dlzky,int delenie_uhla)		// vykresli rotacnu plochu okolo osi x
{
/*
uhol	t0=				smerovy vektor	t1=				smerovy vektor	t2=
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

0		bod0[0][]	->	norm0[0][]		bod1[0][]	->	norm1[0][]		bod2[0][]
1		bod0[1][]	->	norm0[1][]		bod1[1][]	->	norm1[1][]		bod2[1][]
2		bod0[2][]	->	norm0[2][]		bod1[2][]	->	norm1[2][]		bod2[2][]
3		bod0[3][]	->	norm0[3][]		bod1[3][]	->	norm1[3][]		bod2[3][]
4		bod0[4][]	->	norm0[4][]		bod1[4][]	->	norm1[4][]		bod2[4][]
5		bod0[5][]	->	norm0[5][]		bod1[5][]	->	norm1[5][]		bod2[5][]

najprv	vypocitame vsetky body
potom	napr.: z bodov:				vypocitame normalovy vektor prislusneho stvorca
bod0[0][]				bod1[0][]				bod2[0][]
			norm0[0][]				norm1[0][]
bod0[1][]				bod1[1][]				bod2[1][]
			norm0[1][]				norm1[1][]
bod0[2][]				bod1[2][]				bod2[2][]
			norm0[2][]				norm1[2][]
bod0[3][]				bod1[3][]				bod2[3][]

a potom vypocitame vyhladene normalove vektory pre kazdy bod z pola bodov 0 a 1
norm0[0][]				norm1[0][]
			vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
norm0[1][]				norm1[1][]

normalove vektory pre body bod[x][0][] vypocitame :
							norm0[0][]
				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
							norm0[1][]
*/
	float	(*bod0)[3];		// smernik na pole vrcholov, pricom vrchol ma 3 suradnice (je pole 3 suradnic)
	float	(*bod1)[3];		// -- "" --
	float	(*bod2)[3];		// -- "" --
	float	(*pomocny)[3];	// pomocny smernik pouzity pri vymene smernikov
	float	(*text_x);		// smernika na pole x suradnic textur
	float	text_y[2];		// dve hodnoty y suradnic textur
	float	(*norm0)[3];		// normalovy vektor plochy
	float	(*norm1)[3];
	float	(*vnorm0)[3];		// vyhladeny normalovy vektor plochy
	float	(*vnorm1)[3];
	float	a[3],b[3],absolut;	// a,b - vektory, absolut - absolutna hodnota vektora
	int		i,j=0;				// indexove premenne
	float	uhol;				// uhol zvecsujuci sa v smere pravotocivej skrutky tociacej sa v smere x osi  ( pri normalnom pohlade uhos sa zvecsuje smerum k nam )
	float	t0,t1,t2;			// t - parameter
	float	krivka0[3],krivka1[3],krivka2[3];		// hodnoty vratene funkciou RiadiacaKrivka();
	
	bod0  = new float[delenie_uhla][3];			// alokacia pamete pre pole vrcholov
	bod1  = new float[delenie_uhla][3];
	bod2  = new float[delenie_uhla][3];
	norm0 = new float[delenie_uhla][3];
	norm1 = new float[delenie_uhla][3];
	vnorm0= new float[delenie_uhla][3];
	vnorm1= new float[delenie_uhla][3];
	text_x= new float[delenie_uhla];

	t0 = 0;				// ( (float) j / (float) delenie_dlzky );
	RiadiacaKrivka(t0,krivka0);
	text_y[0]=1-t0;				// parametru t=0 prinalezi vrch obrazka ( suradnica y=1)
	t1 = 1.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t1,krivka1);
	text_y[1]=1-t1;
	t2 = 2.0f / (float) delenie_dlzky;
	RiadiacaKrivka(t2,krivka2);

	for(i=0;i<delenie_uhla;i++)
	{
		uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );
		text_x[i]  = 1.0f - (float) i / (float) delenie_uhla;
		// pre uhol=0 prava strana obrazka, pre zvecsujuci sa uhol postupujeme z pravej strany k lavej, pre uhol=360 lava strana obrazku
		
		// vypocet poli bodov, su to vlastne body na kruznici, pricom bod0 ma nizsiu x suradnicu, bod1 , ma najvecsiu x suradnicu bod2
		bod0[i][0] = krivka0[0];
		bod0[i][1] = krivka0[1] * (float) cos( uhol ) - krivka0[2] * (float) sin( uhol );
		bod0[i][2] = krivka0[1] * (float) sin( uhol ) + krivka0[2] * (float) cos( uhol );

		bod1[i][0] = krivka1[0];
		bod1[i][1] = krivka1[1] * (float) cos( uhol ) - krivka1[2] * (float) sin( uhol );
		bod1[i][2] = krivka1[1] * (float) sin( uhol ) + krivka1[2] * (float) cos( uhol );
		
		bod2[i][0] = krivka2[0];
		bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
		bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi nultov a prvou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora							 bod0[i]   bod1[i]
			a[0] = bod1[0][0] - bod1[i][0];				//	+----->
			a[1] = bod1[0][1] - bod1[i][1];				//	 b    |
			a[2] = bod1[0][2] - bod1[i][2];				//	      |
		}												//	    a v   bod1[i+1]
		else		// bod1[delenie_uhla]=bod1[0];
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod1[i][0] - bod0[i][0];
		b[1] = bod1[i][1] - bod0[i][1];
		b[2] = bod1[i][2] - bod0[i][2];
	
		norm0[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm0[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm0[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod0[i+1], bod1[i+1], bod1[i], bod0[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm0[i][0]*norm0[i][0]+norm0[i][1]*norm0[i][1]+norm0[i][2]*norm0[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm0[i][0] = norm0[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm0[i][1] = norm0[i][1]/absolut;
			norm0[i][2] = norm0[i][2]/absolut;
		}
	}

	for(i=0;i<delenie_uhla;i++)		// vypocet normalovych vektorov stvorcov v pase medzi prvou a druhou kruznicou
	{
		if(i == (delenie_uhla-1) )
		{	// vypocet vektora					 bod1[i]  bod2[i]
			a[0] = bod1[0][0] - bod1[i][0];		//	+----->
			a[1] = bod1[0][1] - bod1[i][1];		//	|     b
			a[2] = bod1[0][2] - bod1[i][2];		//	|
		}										//	V a -bod1[i+1]
		else
		{
			a[0] = bod1[i+1][0] - bod1[i][0];
			a[1] = bod1[i+1][1] - bod1[i][1];
			a[2] = bod1[i+1][2] - bod1[i][2];
		}
	
		b[0] = bod2[i][0] - bod1[i][0];
		b[1] = bod2[i][1] - bod1[i][1];
		b[2] = bod2[i][2] - bod1[i][2];
	
		norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
		norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
		norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
		// vypocet velkosti vektora
		absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
		if(absolut>0)		// zabezpecenie proti deleniu nulov
		{
			norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
			norm1[i][1] = norm1[i][1]/absolut;
			norm1[i][2] = norm1[i][2]/absolut;
		}
	}

	//  TERAZ vypocitame vyhladene normalove vektory, a to tak, ze vyhladeny vektor pre bod 
	//	medzi styrmi stvorcami vypocitame ako aritmeticky priemer okolitych normalovych vektorov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//							norm0[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//							norm0[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm0[i][0]=( norm0[i-1][0] + norm0[i][0] )/2.0f;
		vnorm0[i][1]=( norm0[i-1][1] + norm0[i][1] )/2.0f;
		vnorm0[i][2]=( norm0[i-1][2] + norm0[i][2] )/2.0f;
	}
	vnorm0[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] )/2.0f;
	vnorm0[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] )/2.0f;
	vnorm0[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] )/2.0f;

	//	norm0[0][]				norm1[0][]
	//				vnorm1[1][]			--	vyhladeny normalovy vektor pre bod1[1][] 
	//	norm0[1][]				norm1[1][]
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
	{
		vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
		vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
		vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
	}
	vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
	vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
	vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

	glBegin(GL_QUADS);			// kreslime stvorce
	for(i=0;i<(delenie_uhla-1);i++)		// kresime prvy pas stvorcov z lava
	{

		glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
		glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
		glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
		glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
		glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
		glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
		glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
		glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
		glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
		glNormal3fv( vnorm0[i] );				// normalovy v
		glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
		glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
	}
	glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
	glTexCoord2f( 0,text_y[0]);
	glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
	glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
	//glEnd();
	
	// TERAZ vypocitame a nakreslime vsetky pasy okrem posledneho
	for(j=1;j<(delenie_dlzky-1);j++)
	{
		t0 = ( (float) j / (float) delenie_dlzky );
		text_y[0]=1-t0;					// vypocet y suradnice na texture
		t1 = ( (float) (j+1) / (float) delenie_dlzky );
		text_y[1]=1-t1;					// vypocet y suradnice na texture
		t2 = ( (float) (j+2) / (float) delenie_dlzky );
		RiadiacaKrivka(t2,krivka2);
	
		// pole bodov 1 a 2 z predchadzajuceho vypoctu su take iste ako polia bodov 0 a 1, ktore by sme pocitaly v tomto cykle
		// polia bodov preto posunieme a vypocitame iba pole bodov 2
		pomocny = bod0;
		bod0 = bod1;		// vymena poli vrcholov
		bod1 = bod2;
		bod2 = pomocny;
		for(i=0;i<delenie_uhla;i++)
		{
			uhol = piover180 * 360.0f * ( (float) i / (float) delenie_uhla );

			bod2[i][0] = krivka2[0];
			bod2[i][1] = krivka2[1] * (float) cos( uhol ) - krivka2[2] * (float) sin( uhol );
			bod2[i][2] = krivka2[1] * (float) sin( uhol ) + krivka2[2] * (float) cos( uhol );
		}
		// lavy pas stvorcov, ktorych normalove vektory sme vypocitali v predchadzajucom cykle
		// je taky isty ako pravy pas, preto normalove vektory norm0 nemusime pocitat 
		pomocny = norm0;
		norm0 = norm1;
		norm1 = pomocny;
		for(i=0;i<delenie_uhla;i++)				// vypocet normalovych vektorov
		{
			if(i == (delenie_uhla-1) )
			{	// vypocet vektora					 bod1[i]  bod2[i]
				a[0] = bod1[0][0] - bod1[i][0];		//	+----->
				a[1] = bod1[0][1] - bod1[i][1];		//	|     b
				a[2] = bod1[0][2] - bod1[i][2];		//	|
			}										//	V a -bod1[i+1]
			else
			{
				a[0] = bod1[i+1][0] - bod1[i][0];
				a[1] = bod1[i+1][1] - bod1[i][1];
				a[2] = bod1[i+1][2] - bod1[i][2];
			}
	
			b[0] = bod2[i][0] - bod1[i][0];
			b[1] = bod2[i][1] - bod1[i][1];
			b[2] = bod2[i][2] - bod1[i][2];
		
			norm1[i][0] = a[1]*b[2] - a[2]*b[1];		// vektorovy sucin vektorov a, b
			norm1[i][1] = a[2]*b[0] - a[0]*b[2];		// vysledok je vektor kolmy na obidve vektory (a,b)
			norm1[i][2] = a[0]*b[1] - a[1]*b[0];		// vysledok je normalovy vektor stvorca bod1[i+1], bod2[i+1], bod2[i], bod1[i]
			// vypocet velkosti vektora
			absolut = (float) sqrt(norm1[i][0]*norm1[i][0]+norm1[i][1]*norm1[i][1]+norm1[i][2]*norm1[i][2]);
			if(absolut>0)		// zabezpecenie proti deleniu nulov
			{
				norm1[i][0] = norm1[i][0]/absolut;		// urobime z normaloveho vektora jednotkovy (z velkostou 1)
				norm1[i][1] = norm1[i][1]/absolut;
				norm1[i][2] = norm1[i][2]/absolut;
			}
		}
		pomocny = vnorm0;	// vypocet vyhladenych normalovych vektorov pre body bod0[i] nemusime pocitat, lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm0 = vnorm1;	// lebo su to tie iste ako v predchadzajucom kroku pre body bod[1][i]
		vnorm1 = pomocny;
		for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov
		{
			vnorm1[i][0]=( norm0[i-1][0] + norm0[i][0] + norm1[i-1][0] + norm1[i][0] )/4.0f;
			vnorm1[i][1]=( norm0[i-1][1] + norm0[i][1] + norm1[i-1][1] + norm1[i][1] )/4.0f;
			vnorm1[i][2]=( norm0[i-1][2] + norm0[i][2] + norm1[i-1][2] + norm1[i][2] )/4.0f;
		}
		vnorm1[0][0]=( norm0[delenie_uhla-1][0] + norm0[0][0] + norm1[delenie_uhla-1][0] + norm1[0][0] )/4.0f;
		vnorm1[0][1]=( norm0[delenie_uhla-1][1] + norm0[0][1] + norm1[delenie_uhla-1][1] + norm1[0][1] )/4.0f;
		vnorm1[0][2]=( norm0[delenie_uhla-1][2] + norm0[0][2] + norm1[delenie_uhla-1][2] + norm1[0][2] )/4.0f;

		//glBegin(GL_QUADS);
		for(i=0;i<(delenie_uhla-1);i++)		// kreslime pas stvorcov zo suradnicami bodov bod0[i] a bod1[i]
		{
			glNormal3fv( vnorm0[i+1] );				// normalovy vektor pre prvy bod v stvorci
			glTexCoord2f(text_x[i+1],text_y[0]);	// texturove suradnice pre prvy bod v stvorci
			glVertex3fv(   bod0[i+1] );				// prvy bod v stvorci - je v lavo dolnom rohu stvorca 
			glNormal3fv( vnorm1[i+1] );				// normala pre 2. bod
			glTexCoord2f(text_x[i+1],text_y[1]);	// suradnice na texture, ktore sa maju zobrazit na 2. bod
			glVertex3fv(   bod1[i+1] );				// druhy bod - je v pravom dolnom rohu stvorca
			glNormal3fv( vnorm1[i] );				// normalovy vektor pre 3. bod
			glTexCoord2f(text_x[i],text_y[1]);		// suredniece textury, ktore sa zobrazia na 3. bod
			glVertex3fv(   bod1[i] );				// treti bod - je v pravom hornom (vrchnom) rohu stvorca
			glNormal3fv( vnorm0[i] );				// normalovy v
			glTexCoord2f(text_x[i],text_y[0]);		// suradnice textury
			glVertex3fv(   bod0[i] );				// stvrty bod - je v lavom hornom bode stvorca
		}
		glNormal3fv( vnorm0[0] );					// posledny stvorec ktoreho suradnice su na zaciatku t.j. ako pre uhol=0
		glTexCoord2f( 0,text_y[0]);
		glVertex3fv(   bod0[0] );					// suradnice 0 teho bodu: bod0[delenie_uhla] = bod0[0]
		glNormal3fv( vnorm1[0] );
		glTexCoord2f( 0,text_y[1]);
		glVertex3fv(   bod1[0] );					// suradnice dolneho praceho bodu
		glNormal3fv( vnorm1[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
		glVertex3fv(   bod1[delenie_uhla-1] );		// suradnice posledneho bodu v pravo (hore vpravo na texture)
		glNormal3fv( vnorm0[delenie_uhla-1] );
		glTexCoord2f(text_x[delenie_uhla-1],text_y[0]);
		glVertex3fv(   bod0[delenie_uhla-1] );		// suradnice posledneho bodu v lavo (hore vpravo na texture )
		//glEnd();
	}

	// TERAZ vypocitame a nakreslime posledny pas stvorcov
	//	normalove vektory pre body bod[x][0][] vypocitame :
	//	norm1[0][]
	//				vnorm0[1][]			--	vyhladeny normalovy vektor pre bod0[1][] 
	//	norm1[1][]
	// vyhladene vektory pre bod1[i] pozname
	pomocny = vnorm0;
	vnorm0 = vnorm1;
	vnorm1 = pomocny;
	for(i=1;i<delenie_uhla;i++)			// vypocet vyhladenych normalovych vektorov pre body bod2[i]
	{
		vnorm1[i][0]=( norm1[i-1][0] + norm1[i][0] )/2.0f;
		vnorm1[i][1]=( norm1[i-1][1] + norm1[i][1] )/2.0f;
		vnorm1[i][2]=( norm1[i-1][2] + norm1[i][2] )/2.0f;
	}
	vnorm1[0][0]=( norm1[delenie_uhla-1][0] + norm1[0][0] )/2.0f;
	vnorm1[0][1]=( norm1[delenie_uhla-1][1] + norm1[0][1] )/2.0f;
	vnorm1[0][2]=( norm1[delenie_uhla-1][2] + norm1[0][2] )/2.0f;

	//glBegin(GL_QUADS);
	for(i=0;i<(delenie_uhla-1);i++)		// kreslime posledny pas stvorcov, t.j. medzi bodmi bod1[] a bod2[]
	{
		glNormal3fv( vnorm0[i+1] );
		glTexCoord2f(text_x[i+1],text_y[1]);
		glVertex3fv(   bod1[i+1] );
		glNormal3fv( vnorm1[i+1] );
		glTexCoord2f(text_x[i+1],0);
		glVertex3fv(   bod2[i+1] );
		glNormal3fv( vnorm1[i] );
		glTexCoord2f(text_x[i],0);
		glVertex3fv(   bod2[i] );
		glNormal3fv( vnorm0[i] );
		glTexCoord2f(text_x[i],text_y[1]);
		glVertex3fv(   bod1[i] );
	}
	glNormal3fv( vnorm0[0] );
	glTexCoord2f( 0,text_y[1]);
	glVertex3fv(   bod1[0] );
	glNormal3fv( vnorm1[0] );
	glTexCoord2f( 0,0);
	glVertex3fv(   bod2[0] );
	glNormal3fv( vnorm1[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],0);
	glVertex3fv(   bod2[delenie_uhla-1] );
	glNormal3fv( vnorm0[delenie_uhla-1] );
	glTexCoord2f(text_x[delenie_uhla-1],text_y[1]);
	glVertex3fv(   bod1[delenie_uhla-1] );
	glEnd();

	delete[] bod0;			// uvolnujeme pamet
	delete[] bod1;
	delete[] bod2;
	delete[] norm0;
	delete[] norm1;
	delete[] vnorm0;
	delete[] vnorm1;
	delete[] text_x;
}
