#include "bitmap_font.h"

Font::Font(GLuint texture_)						// Build Our Font Display List
{
	number_texture = texture_;
	float	cx;											// Holds Our X Character Coord
	float	cy;											// Holds Our Y Character Coord

	base=glGenLists(256);								// Creating 256 Display Lists
	glBindTexture(GL_TEXTURE_2D, number_texture);		// Select Our Font Texture
	for (loop=0; loop<256; loop++)						// Loop Through All 256 Lists
	{
		cx=float(loop%16)/16.0f;						// X Position Of Current Character
		cy=float(loop/16)/16.0f;						// Y Position Of Current Character

		glNewList(base+loop,GL_COMPILE);				// Start Building A List
			glBegin(GL_QUADS);							// Use A Quad For Each Character
				glTexCoord2f(cx,1.0f-cy-0.0625f);		// Texture Coord (Bottom Left)
				glVertex2i(0,0);						// Vertex Coord (Bottom Left)
				glTexCoord2f(cx+0.0625f,1.0f-cy-0.0625f);	// Texture Coord (Bottom Right)
				glVertex2i(16,0);						// Vertex Coord (Bottom Right)
				glTexCoord2f(cx+0.0625f,1.0f-cy);		// Texture Coord (Top Right)
				glVertex2i(16,16);						// Vertex Coord (Top Right)
				glTexCoord2f(cx,1.0f-cy);				// Texture Coord (Top Left)
				glVertex2i(0,16);						// Vertex Coord (Top Left)
			glEnd();									// Done Building Our Quad (Character)
			glTranslatef(11,0,0);	//10,0,0			// Move To The Right Of The Character
		glEndList();									// Done Building The Display List
	}													// Loop Until All 256 Are Built
}

Font::~Font(GLvoid)									// Delete The Font From Memory
{
	glDeleteLists(base,256);							// Delete All 256 Display Lists
}

GLvoid Font::glPrint(GLint x, GLint y, char *string, int set)	// Where The Printing Happens
{
	if (set>1)set=1;
	glBlendFunc(GL_SRC_ALPHA			,	GL_ONE_MINUS_SRC_COLOR);	// nastavenie mieania farieb
//farba bodu = (pvodn farba * ALPHA)	+	(kreslen farba - pvodn farba)
	glEnable(GL_BLEND);									// povolenie mieania farieb

	glBindTexture(GL_TEXTURE_2D, number_texture);		// Select Our Font Texture
	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,screen_x,0,screen_y,-1,1);				// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
	glTranslated(x,y,0);								// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing

	glDisable(GL_BLEND);								//vypnutie mieania farieb

}

GLvoid Font::glPrint_(GLint x, GLint y, char *string, int set)	// Where The Printing Happens
{
	x = x*11;											// vypocet x zo suradnice stlpca
	y = screen_y - (y+1)*16;							// vypocet y zo suradnice riadka
	
	if (set>1)set=1;
	glBlendFunc(GL_SRC_ALPHA			,	GL_ONE_MINUS_SRC_COLOR);	// nastavenie mieania farieb
//farba bodu = (pvodn farba * ALPHA)	+	(kreslen farba - pvodn farba)
	glEnable(GL_BLEND);									// povolenie mieania farieb

	glBindTexture(GL_TEXTURE_2D, number_texture);		// Select Our Font Texture
	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,screen_x,0,screen_y,-1,1);				// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
	glTranslatef((float)x,(float)y,0);					// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing

	glDisable(GL_BLEND);								//vypnutie mieania farieb

}

GLvoid Font::glPrintFast(GLint x, GLint y, char *string, int set)	// Where The Printing Happens
{
	x = x*11;											// vypocet x zo suradnice stlpca
	y = screen_y - (y+1)*16;							// vypocet y zo suradnice riadka
	glBlendFunc(GL_SRC_ALPHA			,	GL_ONE_MINUS_SRC_COLOR);	// nastavenie mieania farieb
//farba bodu = (pvodn farba * ALPHA)	+	(kreslen farba - pvodn farba)
	glEnable(GL_BLEND);	

	if (set>1)set=1;
//	glBindTexture(GL_TEXTURE_2D, number_texture);		// Select Our Font Texture
//	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
//	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
//	glPushMatrix();										// Store The Projection Matrix
//	glLoadIdentity();									// Reset The Projection Matrix
//	glOrtho(0,screen_x,0,screen_y,-1,1);				// Set Up An Ortho Screen
//	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
//	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
	glTranslatef((float)x,(float)y,0);					// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
//	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
//	glPopMatrix();										// Restore The Old Projection Matrix
//	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
//	glPopMatrix();										// Restore The Old Projection Matrix
//	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
}

void Font::Begin()
{
	glBlendFunc(GL_SRC_ALPHA			,	GL_ONE_MINUS_SRC_COLOR);	// nastavenie mieania farieb
//farba bodu = (pvodn farba * ALPHA)	+	(kreslen farba - pvodn farba)
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, number_texture);		// Select Our Font Texture
	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,screen_x,0,screen_y,-1,1);				// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
}

void Font::End()
{
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDisable(GL_BLEND);								//vypnutie mieania farieb
}



void Font::Print(GLint x, GLint y, char * string, int set)
{
	x = x*11;											// vypocet x zo suradnice stlpca
	y = screen_y - (y+1)*16;							// vypocet y zo suradnice riadka

	if (set>1)set=1;
	glLoadIdentity();									// Reset The Modelview Matrix
	glTranslatef((float)x,(float)y,0);					// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));						// Choose The Font Set (0 or 1)
	glCallLists(strlen(string),GL_BYTE,string);			// Write The Text To The Screen
}
