#include "headers.h"
#include <math.h>
#define piover180	0.0174532925199432957692369076848861f	// pi / 180

extern bool	fullscreen;
extern float	fps;
extern	char	text[20];
POINT MouseBod;
extern HWND		hWnd;
extern Timer   timer0;

void ReSizeGLScene(GLsizei width, GLsizei height);		// funkcia pro zmenu velkosti okna
void Kurzor(void);
void BezierovaKrivka(int pocet_bodov,float bod[][3],int hladkost);
void FergusonovaKRIVKAsegment(float bod[][3],float vektor[][3],int hladkost);
void FergusonovaKrivka(int pocet_bodov,float bod[][3],float vektor[][3],int hladkost);
void ZmazKrivky(void);

int		TypKrivky=1;
typedef float (*typ)[3];
class KRIVKA		//trieda Krivka
{	
	float	(*bod)[3];		// smernika na pole poli
	int		bodov;			// pocet bodov
	float	(*vektor)[3];		// vektory dotycnice pre Fergusobovu krivku
	int		vektorov;			// ocet vektorov pre Fergusobovu krivku
	int		typ_krivky;			// typ krivky Bezierova - 1, Fergusonova - 2
	bool	dokreslena;			// ak je 1 krivka dokreslena
	void	Kresli_mys_BezierovuKrivku(void);	// funkcia ktora kresli Bezierovu krivku v zavislost od mysi
	void	Kresli_mys_FergusonovaKRIVKAsegment(void);	// funkcia ktora kresli Fergusonovu krivku v zavislost od mysi
public:
	KRIVKA(void){bodov=0;vektorov=0;dokreslena=FALSE;typ_krivky=TypKrivky;}		// konstruktor triedy - tato funkcia sa vola hned po vytvoreni (pomocov new)
	void	koniec_kreslenia(void){dokreslena=TRUE;}				// ukonci kreslenie
	void	Kresli(void);											// kresli krivku
	typ		Export(int *pocet_bodov);
	~KRIVKA(void)											// destruktor triedy - vola sa automaticky po delete
	{
		if(bodov>0)delete[]	bod;
		if(vektorov>0)delete[]	vektor;
	}
};
	
typ	KRIVKA::Export(int *pocet_bodov)
{
	int	i;
	float	(*smer)[3];
	if(bodov<1)return NULL;
	smer = new float[bodov+1][3];
	
	for(i=0;i<(bodov+1);i++)
	{
		smer[i][0] = bod[i][0] / (float)(screen_x-1);
		smer[i][1] = bod[i][1] / (float)(screen_y-1);
	}
	*pocet_bodov=bodov+1;	
	return	smer;
}

void KRIVKA::Kresli(void)			// Kresli je clenska funkcia triedy KRIVKA
{
	if(dokreslena)
	{
		switch(typ_krivky)
		{
		case 1:
				BezierovaKrivka(bodov+1,bod,100);
				break;
		case 2:	
				FergusonovaKrivka(vektorov,bod,vektor,50);
				break;
		}
	}
	else
	{
		switch(typ_krivky)
		{
		case 1:
				Kresli_mys_BezierovuKrivku();
				break;
		case 2:	
				Kresli_mys_FergusonovaKRIVKAsegment();
				break;
		}
	}
}

void KRIVKA::Kresli_mys_BezierovuKrivku(void)	// Kresli_mys_BezierovuKrivku je clenska funkcia triedy KRIVKA
{
	float	(*bod1)[3];
	int	i;
	if(keys[VK_LBUTTON])
	{
		bod1=new float[bodov+2][3];
		for(i=0;i<bodov;i++)
		{
			bod1[i][0]=bod[i][0];
			bod1[i][1]=bod[i][1];
			bod1[i][2]=bod[i][2];
		}
		if(bodov>0)delete[] bod;
		bod=bod1;
		
		bod[bodov][0]=(float)MouseBod.x;
		bod[bodov][1]=(float)screen_y-1-MouseBod.y;
		bod[bodov][2]=0;
		bodov++;
		bod[bodov][0]=(float)MouseBod.x;
		bod[bodov][1]=(float)screen_y-1-MouseBod.y;
		bod[bodov][2]=0;
	}
	if(bodov>0)
	{
		bod[bodov][0]=(float)MouseBod.x;
		bod[bodov][1]=(float)screen_y-1-MouseBod.y;
		bod[bodov][2]=0;
		BezierovaKrivka(bodov+1,bod,-100);
	}
}

void	KRIVKA::Kresli_mys_FergusonovaKRIVKAsegment()	// Kresli_mys_FergusonovaKRIVKAsegment je clenska funkcia triedy KRIVKA
{
	float	(*smer)[3];
	int		i;
	if(keys[VK_LBUTTON])
	{
		if(bodov==vektorov)
		{
			bodov++;
			smer=new float[bodov][3];
			for(i=0;i<(bodov-1);i++)
			{
				smer[i][0]=bod[i][0];
				smer[i][1]=bod[i][1];
				smer[i][2]=bod[i][2];
			}
			if(bodov>1)delete[] bod;
			bod=smer;
			
			bod[bodov-1][0]=(float)MouseBod.x;
			bod[bodov-1][1]=(float)screen_y-1-MouseBod.y;
			bod[bodov-1][2]=0;
		}
		else if(bodov>vektorov)
		{
			vektorov++;
			smer=new float[vektorov][3];
			for(i=0;i<(vektorov-1);i++)
			{
				smer[i][0]=vektor[i][0];
				smer[i][1]=vektor[i][1];
				smer[i][2]=vektor[i][2];
			}
			if(vektorov>1)delete[] vektor;
			vektor=smer;
			vektor[vektorov-1][0]=(float)MouseBod.x - bod[bodov-1][0];
			vektor[vektorov-1][1]=(float)screen_y-1-MouseBod.y - bod[bodov-1][1];
			vektor[vektorov-1][2]=0 - bod[bodov-1][2];
		}
	}
	
	if(bodov>0 && vektorov<bodov )
	{
		if(vektorov>0)
		{
			smer=new float[2][3];
			smer[0][0]=vektor[vektorov-1][0];
			smer[0][1]=vektor[vektorov-1][1];
			smer[0][2]=vektor[vektorov-1][2];
			smer[1][0]=(float)MouseBod.x - bod[bodov-1][0];
			smer[1][1]=(float)screen_y-1-MouseBod.y - bod[bodov-1][1];
			smer[1][2]=0 - bod[bodov-1][2];
			FergusonovaKRIVKAsegment(bod+(bodov-2),smer,-100);		//kreslime meniaciu sa krivku
			delete[] smer;
		}
		else 
		{
			glBegin(GL_LINES);
				glColor3f(1,0,0);			//kreslime pohyblivy vektor
				glVertex3fv(bod[bodov-1]);
				glVertex3f((float)MouseBod.x,(float)screen_y-1-MouseBod.y,0);
				glColor3f(1,1,1);
			glEnd();
		}
	}

	if(bodov>0 && vektorov==bodov )
	{
		glBegin(GL_LINES);
			glColor3f(0,0,1);			//kreslime pohyblivu ciaru
			glVertex3fv(bod[bodov-1]);
			glVertex3f((float)MouseBod.x,(float)screen_y-1-MouseBod.y,0);
			glColor3f(1,1,1);
		glEnd();
		
	}
	
	if( vektorov==1 )
	{
		glBegin(GL_LINES);
			glColor3f(1,0,0);			//kreslime nepohyblivy vektor
			glVertex3fv(bod[0]);
			glVertex3f(bod[0][0]+vektor[0][0],bod[0][1]+vektor[0][1],bod[0][2]+vektor[0][2]);
			glColor3f(1,1,1);
		glEnd();
	}

	FergusonovaKrivka(vektorov, bod, vektor,-50);
}

KRIVKA	*kr;
int		i;
extern	bool	modelovanie;
extern	float	(*bod_m)[3];
extern	int	bodov_;

void DrawGLScene_modelovanie(void)				// vlastn kreslenie
{	
	if(keys['M'])
	{
		keys['M']=0;
		if(kr!=NULL) delete kr;
		kr = new KRIVKA;
	}
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glClear(GL_COLOR_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();
	Kurzor();						//zobrazy kurzor a nacita suradnice mysi

	glColor3f(1,1,1);				// biela farba
	//glLineWidth(3);
	kr->Kresli();		// kresli vsetky existujuce krivky
	keys[VK_LBUTTON]=0;
	
	if(keys['1']){TypKrivky=1;keys['1']=0;}			// zmeni typ krivky na Bezierovu
	else if(keys['2']){TypKrivky=2;keys['2']=0;}	// zmeni typ krivky na Fergusonovu

	if(keys[VK_RBUTTON] || keys['K'])				// stlacenim praveho tlacitka na mysi ukonci kreslenie vsetkych kriviek
	{
		keys['K']=0;
		keys[VK_RBUTTON]=0;
		kr->koniec_kreslenia();
		if(bod_m!=NULL) delete[] bod_m;
		bod_m = kr->Export(&bodov_);
		delete kr;
		kr = NULL;
		modelovanie =!modelovanie;
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_DEPTH_TEST);
		if(!fullscreen)
		{	RECT		WindowRect;					//miesto pre velkost okna
			WindowRect.left=(long)0;
			WindowRect.top=(long)0;
			GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov u6ivatelskej casti okna
			ReSizeGLScene(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
		}
		else ReSizeGLScene(screen_x, screen_y);	//definovana v tomto subore
		SetCursorPos(screen_x/2,screen_y/2);				//nastavenie pozicie mysi na stred obrazovky
		return;
	}

	glEnable(GL_TEXTURE_2D);				//povolime texturovanie pre vypisovanie textu lebo je vypnute
	
	
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	gcvt( (double)fps, 4, text);			//prevod realneho cisla na text
	
	font0->Begin();

	font0->glPrintFast(0,0,text,0);					//vypisanie textu na 0 stlpec a 0 riadok
	
	font0->Print(35,0,"Mys: x =",1);
	font0->Print(48,0,"y =",1);
	font0->Print(44,0,itoa(MouseBod.x,text, 10),1);				//x suradnica
	font0->Print(52,0,itoa(screen_y-1-MouseBod.y,text, 10),1);	//y suradnica

//    if(TypKrivky==1)
		font0->Print(10,0,"Type of curve: Bezier",1);
 //   else    glPrintFast(10,0,"Type of curve: Ferguson",1);

/*
	font0->glPrintFast(35,0,"Mys: x =",1);
	font0->glPrintFast(48,0,"y =",1);
	font0->glPrintFast(44,0,itoa(MouseBod.x,text, 10),1);				//x suradnica
	font0->glPrintFast(52,0,itoa(screen_y-1-MouseBod.y,text, 10),1);	//y suradnica

	if(TypKrivky==1)font0->glPrintFast(10,0,"Typ krivky: Bezierova",1);
	else	font0->glPrintFast(10,0,"Typ krivky: Fergusonova",1);*/

	if(keys['H'])							//zobrazenie helpu
	{
        font0->Print(10,3,"Program: Stereographic viewing 02 - modeling control curve",0);
        glColor3f(0.9f,0.9f,1.0f);
        font0->Print(13,4,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
        glColor3f(1.0f,1.0f,1.0f);
        font0->Print(14,6,"Controls:",0);
        font0->Print(15,8,"left mouse button - insert point",1);
        font0->Print(15,9,"right mouse button - end of creating curves",1);
	}
	font0->End();
	glDisable(GL_TEXTURE_2D);
}

void ZmazKrivky(void)		//zmaze krivky a uvolni pamet
{		
	if(kr!=NULL){delete kr; kr = NULL; }
	bodov_=0;
	if(bod_m!=NULL){delete[] bod_m; bod_m=NULL; }
}

#define velkost_kurzoru 5

inline void Kurzor(void)			// zisti poziciu mysi a zobrazy kurzor
{
	GetCursorPos(&MouseBod);		//nacitanie pozicie mysi
	glBegin(GL_LINES);
		glVertex2i(MouseBod.x+velkost_kurzoru,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x-velkost_kurzoru,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x,screen_y-1-MouseBod.y+velkost_kurzoru);
		glVertex2i(MouseBod.x,screen_y-1-MouseBod.y-velkost_kurzoru);
	glEnd();
}
/*inline unsigned long Faktorial(int cislo)				// vypocita faktorial
{
	unsigned long	p;									// do p ukladame medzivysledok
	if(cislo<=1) return 1;
	for(p=1;cislo>1;cislo--)p=p*cislo;
	return p;								//vrati p = cislo!
}

inline unsigned long Comb(int pocet_prvkov,int trieda)	// kombinacie
{
	return Faktorial(pocet_prvkov)/( Faktorial(trieda)*Faktorial( pocet_prvkov - trieda ) );
}*/

inline long double Faktorial(int cislo)				// vypocita faktorial pozor 13! > 2^31
{
	long double	p;									// do p ukladame medzivysledok
	if(cislo<=1) return 1;
	for(p=1;cislo>1;cislo--)p=p*cislo;
	return p;								//vrati p = cislo!
}

inline long double Comb(int pocet_prvkov,int trieda)	// kombinacie
{
	return Faktorial(pocet_prvkov)/( Faktorial(trieda)*Faktorial( pocet_prvkov - trieda ) );
}

inline float mocnina(float cislo,int mocnina)
{
	float p=1.0f;
	while(mocnina--) p *= cislo;
	return p;
}

/*	Aproximacne ciary
	Do tejto skupiny patria krivky, ktore su zadane lomenou ciarov - polygonom
	s cielom vytvorit "hladku" krivku, ktora zhruba sleduje tvar tejto lomenej ciary.
	Vyhoda navrhu takejto krivky je v tom, ze zmenou tvaru polygonnu mozno lachko
	menit tvar krivky a dospiet k vysledku podla predstavy navrhovatela.

	Patria sem:		Bezierova krivka	- vid nizsie
					B-slajn krivka		- kto ju ma vytvorenu nech mi posle		*/

void BezierovaKrivka(int stupen,float bod[][3],int hladkost)		//stupen == pocet bodov, smernik na body
{
	bool	nakresli_usecky=FALSE;
	float	t;			// t - parameter pri vypocte bodov
	float	a[3];		// miesto pre vypocitany bod
	float*	B;			// smernika na koeficienty
	float*	comb;		// smernika na vypocitane kombinacie
	int		i,j;		// pomocne indexne premenne

	if(stupen<2)return;
	--stupen;			// teraz je to skutocny stupen vzniknutych Bernstejnovych polynomov
	if(hladkost==0)hladkost=3;	// co ked nahodov ?
	else if(hladkost<0){hladkost=-hladkost;nakresli_usecky=TRUE;}	//ked je hladkost zaporna zobrazia sa aj usecky
	B = new float[stupen+1];				// alokacia pamete pre vypocet koeficientov
	comb = new float[stupen+1];				// alokacia pamete pre vypocet kombinacii

	for(j=0;j<=stupen;j++)comb[j]=(float)Comb(stupen,j);		// vypocet potrebnych kombinacii

	glBegin(GL_LINE_STRIP);			// kreslime pospajane ciary
		for(i=0;i<=hladkost;i++)	// vypocitavame a kreslime vsetky body 0,1,...,(hladkost)
		{
			t=(float)i /(float)hladkost;	// vypocitame parameter pre dany bod
			for(j=0;j<=stupen;j++)			// vypocitavame koeficienty
				B[j] = comb[j] * mocnina(t,j) *	mocnina( (1.0f-t),(stupen-j) );

			a[0]=0;a[1]=0;a[2]=0;			// nulujeme bod
			for(j=0;j<=stupen;j++)			// vypocitame suradnice bodu
			{
				a[0]+=bod[j][0]*B[j];
				a[1]+=bod[j][1]*B[j];
				a[2]+=bod[j][2]*B[j];
			}
		glVertex3fv(a);						// zobrazime usecku z predchadzajuceho bodu az do tohto
		}
	glEnd();
	if(nakresli_usecky)						// ak bola hladkost < 0 nakreslime aj lomenu ciaru
	{
		glBegin(GL_LINE_STRIP);				// kreslime pocpajene ciary
			glColor3f(0,0,1);				// modra farba
			for(j=0;j<=stupen;j++)glVertex3fv( bod[j]);		// kreslime ciaru od posledneho bodu az po aktualny
			glColor3f(1,1,1);				// naspat biala farba
		glEnd();
	}
	
	delete []comb;							// uvolnujeme pamet
	delete []B;								// --""--
}

void FergusonovaKRIVKAsegment(float bod[][3],float vektor[][3],int hladkost)
{
	bool	nakresli_usecky=FALSE;
	float	t;			// t - parameter pri vypocte bodov
	float	a[3];		// miesto pre vypocitany bod
	float	F[4];		// koeficienty
	int		i;		// pomocne indexne premenne

	if(hladkost==0)hladkost=3;	// co ked nahodov ?
	else if(hladkost<0){hladkost=-hladkost;nakresli_usecky=TRUE;}	//ked je hladkost zaporna zobrazia sa aj usecky
	glBegin(GL_LINE_STRIP);			// kreslime pospajane ciary
		for(i=0;i<=hladkost;i++)	// vypocitavame a kreslime vsetky body 0,1,...,(hladkost)
		{
			t=(float)i /(float)hladkost;	// vypocitame parameter pre dany bod
			F[0] =  2*t*t*t - 3*t*t + 1;
			F[1] = -2*t*t*t + 3*t*t;
			F[2] =    t*t*t - 2*t*t + t;
			F[3] =    t*t*t -   t*t;

			a[0] = bod[0][0]*F[0] + bod[1][0]*F[1] + vektor[0][0]*F[2] + vektor[1][0]*F[3];
			a[1] = bod[0][1]*F[0] + bod[1][1]*F[1] + vektor[0][1]*F[2] + vektor[1][1]*F[3];
			a[2] = bod[0][2]*F[0] + bod[1][2]*F[1] + vektor[0][2]*F[2] + vektor[1][2]*F[3];

			glVertex3fv(a);						// zobrazime usecku z predchadzajuceho bodu az do tohto
		}
	glEnd();
	if(nakresli_usecky)
	{
		glColor3f(0,0,1);
		glBegin(GL_LINES);
			glVertex3fv(bod[0]);
			glVertex3fv(bod[1]);
		glColor3f(1,0,0);
			glVertex3fv(bod[0]);
			glVertex3f(bod[0][0]+vektor[0][0],bod[0][1]+vektor[0][1],bod[0][2]+vektor[0][2]);
			glVertex3fv(bod[1]);
			glVertex3f(bod[1][0]+vektor[1][0],bod[1][1]+vektor[1][1],bod[1][2]+vektor[1][2]);
		glEnd();
		glColor3f(1,1,1);
	}
}

void FergusonovaKrivka(int pocet_bodov,float bod[][3],float vektor[][3],int hladkost)	//vola funkciu FergusonovaKRIVKAsegment (pocet_bodov-1) krat
// pole bod    musi byt inicializovane (minimalne) na velkost    bod[pocet_bodov][3]
// pole vektor musi byt inicializovane (minimalne) na velkost vektor[pocet_bodov][3]
// hladkost je pre kazdy usek rovnaky a = |hadkost|
{
	int		i;
	if( pocet_bodov>1)
	{
		for(i=0;i<(pocet_bodov-1);i++)FergusonovaKRIVKAsegment(bod+i,vektor+i,hladkost);
	}
}

void BezierovaKrivka_modelovanie(int stupen,float bod[][3],float t,float bod_vystup[3])		//stupen == pocet bodov, smernik na body
{
	float*	B;			// smernika na koeficienty
	float*	comb;		// smernika na vypocitane kombinacie
	int		j;			// pomocne indexne premenne

	if(stupen<2)return;
	--stupen;			// teraz je to skutocny stupen vzniknutych Bernstejnovych polynomov
	B = new float[stupen+1];				// alokacia pamete pre vypocet koeficientov
	comb = new float[stupen+1];				// alokacia pamete pre vypocet kombinacii

	for(j=0;j<=stupen;j++)comb[j]=(float)Comb(stupen,j);		// vypocet potrebnych kombinacii

	for(j=0;j<=stupen;j++)			// vypocitavame koeficienty
		B[j] = comb[j] * mocnina(t,j) *	mocnina( (1.0f-t),(stupen-j) );

	bod_vystup[0]=0;bod_vystup[1]=0;bod_vystup[2]=0;			// nulujeme bod
	for(j=0;j<=stupen;j++)			// vypocitame suradnice bodu
	{
		bod_vystup[0] +=bod[j][0]*B[j];
		bod_vystup[1] +=bod[j][1]*B[j];
		//bod_vystup[2] +=bod[j][2]*B[j];
	}

	delete []comb;							// uvolnujeme pamet
	delete []B;								// --""--
}